<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>JavaScript Arrow Functions</title>
</head>

<body>
    <script src="accounts.js"></script>
    <script>
        let cities = [
            {
                name: 'Tallinn',
                country: 'Estonia',
                population: 434562
            },
            {
                name: 'Tartu',
                country: 'Estonia',
                population: 93865
            },
            {
                name: 'Valga',
                country: 'Estonia',
                population: 12992
            },
            {
                name: 'Võru',
                country: 'Estonia',
                population: 12367
            },
            {
                name: 'Helsinki',
                country: 'Finland',
                population: 650058
            },
            {
                name: 'Espoo',
                country: 'Finland',
                population: 284444
            },
            {
                name: 'Hanko',
                country: 'Finland',
                population: 8386
            },
            {
                name: 'Jämsä',
                country: 'Finland',
                population: 20589
            },
            {
                name: 'Stockholm',
                country: 'Sweden',
                population: 972647
            },
            {
                name: 'Uppsala',
                country: 'Sweden',
                population: 168096
            },
            {
                name: 'Lund',
                country: 'Sweden',
                population: 91940
            },
            {
                name: 'Köping',
                country: 'Sweden',
                population: 17743
            }
        ];

        // Ex 25
        // 1
        let cust1 = accounts.find(c => c.number === 'EE154770478');
        console.log("1", cust1);

        // 2
        let cust2 = accounts.find(customer => customer.number === 'LT937416401');
        console.log("2", cust2);

        // 3
        let custExists = accounts.some(c => c.number === "LV587816561");
        console.log("3", custExists);

        // 4
        custExists = accounts.some(c => c.number === "EE251446912");
        console.log("4", custExists);

        // 5
        let ritchCustomers = accounts.filter(c => c.balance > 500);
        console.log("5", ritchCustomers);

        // 6
        // Variant 1
        let totalSuperRitchCustomers = accounts
            .filter(c => c.balance > 1000)
            .reduce((currentTotal, customer) => { return currentTotal + customer.balance }, 0);
        console.log("6: Variant 1", totalSuperRitchCustomers);

        // Variant 2
        let totalSuperRitch2 = 0;
        let superRictch = accounts.filter(c => c.balance > 1000);
        superRictch.forEach(c => totalSuperRitch2 = totalSuperRitch2 + c.balance);
        console.log("6: Variant 2", totalSuperRitch2);

        // Variant 3
        let totalSuperRitch3 = 0;
        for (let i = 0; i < accounts.length; i++) {
            if (accounts[i].balance > 1000) {
                totalSuperRitch3 = totalSuperRitch3 + accounts[i].balance;
            }
        }
        console.log("6: Variant 3", totalSuperRitch3);

        // Ex7
        // Variant 1
        let totalBalanceAllAccounts = accounts
            .reduce((currentTotal, account) => currentTotal + account.balance, 0);
        console.log("7: Variant 1", totalBalanceAllAccounts);

        // Variant 2
        totalBalanceAllAccounts = 0;
        accounts.forEach(account => totalBalanceAllAccounts = totalBalanceAllAccounts + account.balance);
        console.log("7: Variant 2", totalBalanceAllAccounts);

        // Ex 8
        let totalBalanceEstonians = accounts.filter(a => a.number.startsWith("EE"))
            .reduce((currentTotal, account) => currentTotal + account.balance, 0);
        console.log("8", totalBalanceEstonians);

        // Ex 9
        let totalBalanceLatvians = accounts.filter(a => a.number.startsWith("LV"))
            .reduce((currentTotal, account) => currentTotal + account.balance, 0);
        let countLatvians = accounts.filter(a => a.number.startsWith("LV")).length;
        let avgBalanceLatvians = totalBalanceLatvians / countLatvians;
        console.log("9", avgBalanceLatvians);

        // Ex 10
        // Variant 1
        let totalBalanceMaleLithuanians = accounts
            .filter(a => a.number.startsWith("LT"))
            .filter(a => a.gender === "M")
            .reduce((currentTotal, account) => currentTotal + account.balance, 0);
        console.log("10: Variant 1", totalBalanceMaleLithuanians);

        // Variant 2
        totalBalanceMaleLithuanians = accounts
            .filter(a => a.number.startsWith("LT") && a.gender === "M")
            .reduce((currentTotal, account) => currentTotal + account.balance, 0);
        console.log("10: Variant 2", totalBalanceMaleLithuanians);

        // Ex 11
        console.log("11: Variant 1");
        for (let i = 0; i < accounts.length; i++) {
            if (accounts[i].number.startsWith("LT")) {
                console.log(`Name: ${accounts[i].firstName} ${accounts[i].lastName}`);
            }
        }

        console.log("11: Variant 2");
        accounts.forEach(a => {
            if (a.number.startsWith("LT")) {
                console.log(`Name: ${a.firstName} ${a.lastName}`);
            }
        });

        console.log("11: Variant 3");
        let ltCustNames = accounts.filter(a => a.number.startsWith("LT")).map(la => `${la.firstName} ${la.lastName}`);
        console.log(ltCustNames);

        // Ex 12
        let anyPoorLatvians = accounts.filter(a => a.number.startsWith("LV")).some(a => a.balance < 100);
        console.log("12", anyPoorLatvians);

        // Ex 13
        let allAccountsHaveMoney = accounts.every(a => a.balance >= 1);
        console.log("13", allAccountsHaveMoney);

        // Ex 14
        let totalEstonians = accounts.filter(a => a.number.startsWith('EE')).reduce((ct, a) => ct + a.balance, 0);
        let totalLatvians = accounts.filter(a => a.number.startsWith('LV')).reduce((ct, a) => ct + a.balance, 0);
        let totalLithuanians = accounts.filter(a => a.number.startsWith('LT')).reduce((ct, a) => ct + a.balance, 0);
        let countryBalances = {
            estonia: totalEstonians,
            latvia: totalLatvians,
            lithuania: totalLithuanians
        };
        console.log('14', countryBalances);
    </script>
</body>

</html>